(* type utilisateur qui permet d'utiliser le "vrai" compare et non pas un truc inliné ou trop optimisé *)
type t = {
 a : int;
 b : int;
}

(* créer un vecteur non trié *)
let test size =
  let a = Array.make size {a=0;b=0} in
   for i = 0 to size - 1 do
     a.(i) <- {a=Random.int 1000000; b=Random.int 1000000}
   done;
   a

(* créer un tableau de "vecteurs non triés" *)
let matrix =
  let n = (16) in
  let m = Array.make n [||] in
 for i = 0 to n - 1 do
   m.(i) <- test 100_000
 done;
   m

(* tri multifil *)
let threaded_sort : 'a array array -> unit = fun m ->
  let t = Array.make (Array.length m) (Thread.create (fun () -> ()) ()) in
   for i = 0 to Array.length m - 1 do
     print_endline ("............");
     t.(i) <-
       Thread.create
       (fun () -> Array.sort compare m.(i))
       ()
   done;
   Array.iter Thread.join t

(* lancement... *)
let main () =
  let cpt = ref 0 in
 threaded_sort matrix ;
 for i = 0 to Array.length matrix - 1 do
   for a = 0 to Array.length matrix.(i) - 2 do
     let b = a + 1 in
       if (matrix.(i).(a) <= matrix.(i).(b)) then incr cpt
       else (failwith ("et PAN!" ^ string_of_int !cpt))
   done
 done

let _ = main ()
let _ = print_endline "It  works!"

let _ = while true do
let _ =  let n = (52) in
  let m = Array.make n [||] in
 for i = 0 to n - 1 do
   m.(i) <- test 100_000
 done;
   m
in ()

done
